import os
import numpy as np
import time
import sys
import torch
from ChexnetTrainer import ChexnetTrainer
os.environ["CUDA_VISIBLE_DEVICES"] ="6"
#-------------------------------------------------------------------------------- 

def main ():
    
    
    #runTest()
    runTrain()
  
#--------------------------------------------------------------------------------   

def runTrain():
    
    DENSENET121 = 'DENSE-NET-121'
    DENSENET169 = 'DENSE-NET-169'
    DENSENET201 = 'DENSE-NET-201'
    
    timestampTime = time.strftime("%H%M%S")
    timestampDate = time.strftime("%d%m%Y")
    timestampLaunch = timestampDate + '-' + timestampTime
    
    #---- Path to the directory with images
    pathDirData = '/home/xujing/data/data_imgs/images'
    
    #---- Paths to the files with training, validation and testing sets.
    #---- Each file should contains pairs [path to image, output vector]
    #---- Example: images_011/00027736_001.png 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    pathFileTrain = './dataset/train_2.txt'
    pathFileVal = './dataset/val_2.txt'
    pathFileTest = './dataset/test_2.txt'
    
    #---- Neural network parameters: type of the network, is it pre-trained 
    #---- on imagenet, number of classes
    nnArchitecture = DENSENET121
    nnIsTrained = True
    nnClassCount = 14
    
    #---- Training settings: batch size, maximum number of epochs
    trBatchSize = 128
    trMaxEpoch = 100
    
    #---- Parameters related to image transforms: size of the down-scaled image, cropped image
    imgtransResize = 256
    imgtransCrop = 224
        
    pathModel = 'm-' + timestampLaunch + '.pth.tar'
   
    
    print ('Training NN architecture = ', nnArchitecture)
    ChexnetTrainer.train(pathDirData, pathFileTrain, pathFileVal, nnArchitecture, nnIsTrained, nnClassCount, trBatchSize, trMaxEpoch, imgtransResize, imgtransCrop, timestampLaunch, None)
    
    #print ('Testing the trained model')
    #with torch.no_grad():
        #ChexnetTrainer.test(pathDirData, pathFileTest, pathModel, nnArchitecture, nnClassCount, nnIsTrained, trBatchSize, imgtransResize, imgtransCrop, #timestampLaunch)
    
 

#-------------------------------------------------------------------------------- 

def runTest():
    
    
    for i in range(1):
        if 1:
            pathDirData = '/home/xujing/data/data_imgs/images'
            pathFileTest = './dataset/test_2.txt'
            nnArchitecture = 'DENSE-NET-121'
            nnIsTrained = True
            nnClassCount = 14
            trBatchSize = 1
            imgtransResize = 256
            imgtransCrop = 224
    
            pathModel = "/home/xujing/chexnet-master/m-8.pth.tar"

            print(pathModel)
            timestampLaunch = ''
            with torch.no_grad():
                ChexnetTrainer.test(pathDirData, pathFileTest, pathModel, nnArchitecture, nnClassCount, nnIsTrained, trBatchSize, imgtransResize, imgtransCrop, timestampLaunch)
        
    

#-------------------------------------------------------------------------------- 

if __name__ == '__main__':
    #main()
    runTest()





